#+----------------------------------------+
#|    BULLETIN BOARD Ver0.32  00/01/20    |
#|            b_board_lib.pl              |
#|  (c)1997-2000 Perl Script Laboratory   |
#|        akira67@po.jah.ne.jp            |
#|     http://www.jah.ne.jp/~akira67/     |
#| Υץȷϥե꡼Ǥ |
#| ݡȥڡѵ餷Ƥ |
#|                                |
#+----------------------------------------+
# ̥饤֥Ǥ

sub file_lock {
     local($wait) = 5;
     while (!symlink(".", "$lock_dir/b_board.lock")) {
          if (--$wait <= 0) {
               &error('߻ǤФ餯äƤ'.
                      'Ƥ'
               );
          }
          sleep (1);
     }
}

sub file_unlock {
     unlink ("$lock_dir/b_board.lock");
}

sub set_cookies {

     local(@cookie_data) = @_;
     local($cookie_data) = join('|||', @cookie_data);

     print "Set-Cookie: b_board=$cookie_data; ",
           "expires=", &cookie_date_formatting($exp_days*24*60), "; \n";
}

sub cookie_date_formatting {

     local($_) = @_;
     ($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime(time + $_ * 60);
     $sec  = "0$sec"  if $sec  < 10;
     $min  = "0$min"  if $min  < 10;
     $hour = "0$hour" if $hour < 10; # η·
     $year += 1900;
     $week = ("Sunday","Monday","Tuesday","Wednesday","Thursday",
              "Friday","Saturday")[$wday];
     $mon  = ('Jan','Feb','Mar','Apr','May','Jun',
             'Jul','Aug','Sep','Oct','Nov','Dec')[$mon];
     $_    = "$week\, $mday-$mon-$year $hour:$min:$sec GMT";
     $_;
}

sub get_cookies {

     local(@cookie_data) = split(/\|\|\|/, &cookie_split);
     @cookie_data;
}

sub cookie_split {

     local($name, $value, $cookie_data);
     foreach (split(/; /, $ENV{'HTTP_COOKIE'})) {
          ($name, $value) = split(/=/);
          if ($name eq 'b_board') {
               $cookie_data = $value;
               $flag = 1;
               last;
          }
     }
     $cookie_data;
}

sub date_formatting {

     local($_) = @_;
     ($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime($_);
     $mon++;
     $mon  = "0$mon"  if $mon  < 10;
     $mday = "0$mday" if $mday < 10;
     $sec  = "0$sec"  if $sec  < 10;
     $min  = "0$min"  if $min  < 10;
     $hour = "0$hour" if $hour < 10; # η·
     $year += 1900;
     $week = ("Sun","Mon","Tue","Wed","Thu","Fri","Sat")[$wday];
     $_    = "$year/$mon/$mday($week) $hour:$min:$sec";
     $_;
}

sub error {

     &file_unlock;

     print <<HEADER;
Content-type: text/html

<HTML><HEAD><TITLE>$title</TITLE></HEAD>
<BODY TEXT="#006858" BGCOLOR="#EEEEBB">
<BLOCKQUOTE>
<H2>$title 顼</H2>
HEADER

     foreach (@_) { print "<B>$_</B><BR>\n"; }

     print <<FOOTER;
<P><DIV ALIGN=right><FORM>
<INPUT TYPE=button VALUE=ᡡ onClick=history.back()>
<HR NOSHADE><B><SMALL>$prod_name v$version
<A HREF=$a_url TARGET=_top>$signature</A></B></SMALL></DIV></BLOCKQUOTE>
</FORM></BODY></HTML>
FOOTER

     exit;
}

sub setver {

     # Υ֥롼ѹʤǤ
     $prod_name = 'Bulletin Board';
     $version   = '0.32';
     $signature = 'Author\'s page';
     $a_email   = 'akira67@po.jah.ne.jp';
     $a_url     = 'http://www.jah.ne.jp/~akira67/';
}

1;
